<template>
  <Bar :data="preparedData" :options="options" />
</template>

<script>
import { Bar } from 'vue-chartjs';
import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale
} from 'chart.js';

ChartJS.register(CategoryScale, LinearScale, BarElement, Title, Tooltip, Legend);

export default {
  name: "BarChart",
  components: {
    Bar
  },
  props: {
    // eslint-disable-next-line vue/require-default-prop
    chartData: {
      type: [Array, Object],
      required: true
    },
    chartLabels: {
      type: Array,
      required: true
    },
    chartBackgroundColors: {
      type: Array,
      required: false,
      default () {
        return [
          'rgb(41, 114, 170)',
          'rgb(242, 242, 242)',
          'rgb(159, 242, 223)'
        ]
      }
    },
    title: {
      type: String,
      default: '[No title]',
      required: false
    }
  },
  data() {
    return {
      preparedData: {
        labels: this.chartLabels,
        datasets: [
          {
            data: this.chartData,
            title: '',
            labels: this.chartLabels,
            backgroundColor: this.chartBackgroundColors[0]
          }
        ]
      },
      options: {
        title: {
          display: false,
          text: this.title
        },
        // responsive: true,
        // maintainAspectRatio: false,
        scales: {
          xAxes: [{
            stacked: true,
            ticks: {
              // this will fix your problem with NaN
              callback: function (label) {
                return label || ''
              }
            }
          }],
          yAxes: [{
            ticks: {
              beginAtZero: true,
              max: 100
            }
          }]
        },
        plugins: {
          legend: {
            display: false
          },
          tooltip: {
            // Toolbar an/aus
            enabled: true
          },
          datalabels: {
            display: true,
            anchor: 'end',
            align: 'top',
            offset: -3,
            formatter: value => value === 0? '' : `${value}%`
          }
        }
      }
    }
  }
};
</script>
